﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DarwinDotNet
{
    /// <summary>
    /// TODO
    /// </summary>
    /// <remarks>
    /// TODO
    /// </remarks>
    public abstract class Operator
    {
        protected static Random _rand = new Random(); // Random number generator.

        public Operator(Func<Population, double> probabilityFunction)
            : this()
        {
            this.ProbabilityFunction = probabilityFunction;
        }

        public Operator()
        {
        }

        public Func<Population, double> ProbabilityFunction
        {
            get;
            set;
        }

        public abstract void Perform(Population population);
    }
}
